/********************************************************           
 * gen -- program to generate file tree replica         *   
 *                                                      * 
 *	  with 0B file size.                            * 
 *                                                      *   
 * Author:  Jaakko Lappalainen - 2011                   *   
 * email: jaakko@torroja.dmt.upm.es                     *   
 *                                                      *   
 ********************************************************/  

#include "gen.h"

extern int line, col;
extern char *yytext;
extern FILE *yyin;
extern int yyparse();
extern FILE *out;
extern FILE *l;
char * target;
char cmd[50];

int execCmd(char *s, const char* format, ...){
	char cmd[50];
	
	va_list args;
  	va_start(args, format);

	sprintf(cmd, s, format, args);
	if( system(cmd) != 0 ){
		fprintf(stderr, "Error executing %s\n", cmd);
		return -1;
	}
	return 0;	
}


int main(int argc, char **argv)
{
	if(argc == 3){
		execCmd("find %s > input", argv[2]);
		if ((yyin = fopen("input", "r")) == NULL){
			fprintf(stderr, "fopen: Input file error\n");
			return -1;
		}
		sprintf(cmd, "%s.log", argv[1]);
		if ((l = fopen(cmd, "w")) == NULL){
			fprintf(stderr, "fopen: Output file error\n");
			return -1;
		}
	}

	else{
		printf("usage: gen <machine-name> <input-path>\n");
		return -1;
	}

	fprintf(stdout, "\n-------------------------------------------------------------\n");
	fprintf(stdout, "  gen - a program to generate a given file tree replica\n\twith 0B file size. Real size is appended to\n\tfilename between '[' ']'.\n\n\t* Author: Jaakko Lappalainen\n\t* Year: 2011\n\t* Email: jaakko@torroja.dmt.upm.es\n");
	fprintf(stdout, "-------------------------------------------------------------\n\n");
	//fprintf(stdout, "Output will be generated in ./%s\n", argv[1]);
	target = (char*) malloc(sizeof(char)*strlen(argv[1]));
	strcpy(target, argv[1]);
	sprintf(cmd, "%s.out",argv[1]);
	if ((out = fopen(cmd, "w")) == NULL){
        	fprintf(stderr, "fopen: Output file error\n");
                return -1;
        }
	if ((yyparse()) != TOK_ERROR) {
	}

	fprintf(stdout, "\n\n* See standard output for errors, %s.log file for success generations.\n\n",argv[1]);
	if(argc == 3){
		fclose(yyin);
		fclose(out);
		fclose(l);
	}

	//fprintf(stderr,"Compressing result in %s.tgz...", target);
	//sprintf(cmd, "tar -czf %s.tgz %s", target,target);
	//system(cmd);
	//fprintf(stderr," Done.\n");
	free(target);
	system("rm input");
	return 0;
}
