%{

#include "gen.h"

extern int yylex();
extern char *yytext;
extern char *target;

FILE *l;
FILE *out;
off_t size;
uintmax_t sizeU;
long double double_size;
char unit;
int rc = 0;
struct stat fileData; 
int line, col;
//char str[MAX_STR];
long int dirs, files;

int yyerror(char *s) {
	printf("Syntax error:%d:%d: (\"%s\")\n", line, col, yytext);
	return -1;
}

static uintmax_t unsigned_file_size (off_t size)
{
  return size + (size < 0) * ((uintmax_t) INT_MAX - INT_MIN + 1);
}
%}

%union {
	att a;  
}

%token TOK_STR;
%token TOK_CR;

%type <a> LISTA
%type <a> CADENA

%%
INICIO: start LISTA end {};

start: {
	files = dirs = 0;
	fprintf(l, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	/*Add more pre-gen info 'fprintfs' only above this comment */
	fprintf(l, "'*' count the number of files processed per collection\n ");
	
};

LISTA : LISTA CADENA {} | CADENA {};

CADENA: TOK_STR TOK_CR {

	/* tell from file and folder */

	/* get file size */
	lstat($$.lexeme, &fileData);

	/* dir */
	if (S_ISDIR (fileData.st_mode)){
		//fprintf(stderr, "\"%s\" es un dir\n",$$.lexeme);
		fprintf(l, "\nProcessing:[%s] ",$$.lexeme);
		//sprintf(str, "mkdir -p ./%s%s",target, $$.lexeme);
		//system(str);
		fprintf(out,"%s\nDIR\n", $$.lexeme);
		dirs++;
	}

	/* regular file */
	if (S_ISREG (fileData.st_mode)){
		sizeU = unsigned_file_size(fileData.st_size);
		//fprintf(stderr, "size: %s\n", readable_fs(size, sizeStr));
		rc = 0;
		double_size = (long double)sizeU;		
		while(double_size > 1024){
			double_size /= 1024; rc++;
		}
		switch(rc){
			case 0: unit = 'B'; break;
			case 1: unit = 'K'; break;
			case 2: unit = 'M'; break;
			case 3: unit = 'G'; break;
			case 4: unit = 'T'; break;
			case 5: unit = 'P'; break;
			case 6: unit = 'E'; break;
			default: unit = '?'; break;
		}
		fprintf(l, "*");
		//sprintf(str, "touch ./%s%s:[%.1Lf%c]",target, $$.lexeme, double_size, unit);
		//system(str);
		fprintf(out, "%s\n%.1Lf%c\n", $$.lexeme, double_size, unit);
		files++;
	}

	/* symbolic link */
	if (S_ISLNK (fileData.st_mode)){
		//fprintf(stderr, "%s es un link\n",$$.lexeme);
	}

	
};
end: { 
	fprintf(l, "\n");
	//rewind(l);
	fprintf(l, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	/*Add more pre-process info 'fprintfs' only above this comment */
	fprintf(l, "Success processed items: ");
	fprintf(l, "%ld directories, %ld files\n",dirs, files);
	/*Add more post-process info 'fprintfs' only below this comment */
	fprintf(l, "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
};


